open Alcotest
open Base
open Oksql
open Utils
open Okauth_server

let test_should_init_database =
  test_case "should init database" `Quick begin fun () ->
    with_tmp_file begin fun db_path ->
      let stdout = ref "" in
      let module T = MockTerminal.Make(struct
          let stdout = stdout
          let password = ""
          let confirmation = true
        end) in
      let module Adm = Administrator.Make(struct
          module Terminal = T
          let db_path = db_path
        end) in

      let result = Adm.init () in
      (check (Alcotest.result unit string))
        "command returned error"
        (Result.Ok ())
        result;
      with_db db_path begin fun db ->
        (check bool)
          "init did not initialize database"
          true
          (has_table db "users" && has_table db "applications")
      end;

      (check string)
        "command output is incorrect"
        "Done\n"
        !stdout
    end
  end

let cases = [
  test_should_init_database;
]
